#ifndef __ndk_pager_h__
#define __ndk_pager_h__

#define CR0_PAGING_ENABLE	(0x80000000)

// available for use in page directories and tables...
#define PAGE_PRESENT		(1)
#define PAGE_READ_WRITE		(2)
#define PAGE_P3_ACCESS		(4)
#define PAGE_WRITE_THROUGH	(8)
#define PAGE_CACHE_DISABLE	(16)
#define PAGE_ACCESSED		(32)

// page directories only
#define PAGE_SIZE_4MB		(128)

// page tables only
#define PAGE_DIRTY		(64)

typedef struct {
  long pageTable[1024];
} pageDirectory __attribute__ ((packed));

typedef struct {
  long pageAddr[1024];
} pageTable __attribute__ ((packed));

extern pageDirectory *sysPageDir;

void  pagerInit(void);
long  pagerMapPage(unsigned long physAddr);
void *pagerLinToPhys(void *linAddr);

#endif
