#ifndef __ndk_timer_h__
#define __ndk_timer_h__

#include "ndk.h"
#include "pic.h"
#include "idt.h"
#include "isr.h"
#include "task.h"
#include "pmode.h"
#include "descgate.h"

// Port delcarations
#define TIMER0_CNTR (0x40)
#define TIMER1_CNTR (0x41)
#define TIMER2_CNTR (0x42)
#define TIMER_CTRL  (0x43)

// for use with TIMER_CTRL port
#define TIMER0      (0 << 6)
#define TIMER1      (1 << 6)
#define TIMER2      (2 << 6)

#define TIMER_LATCH (0 << 4)
#define TIMER_LSB   (1 << 4)
#define TIMER_MSB   (2 << 4)
#define TIMER_WHOLE (TIMER_LSB + TIMER_MSB)

#define TIMER_MODE0 (0 << 1)
#define TIMER_MODE1 (1 << 1)
#define TIMER_MODE2 (2 << 1)
#define TIMER_MODE3 (3 << 1)
#define TIMER_MODE4 (4 << 1)
#define TIMER_MODE5 (5 << 1)

#define TIMER_BIN16 (0)
#define TIMER_BCD   (1)

#define PIT_FREQ (0x1234DD)

extern long timerTicks;

void timerInit(void);
void timerSetFreq(short freq);
void timerHandler(void);
void timerScheduler(void);
long timerGetTicks(void);

#endif
